Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Class Members | File Members

# TF_DecryptorBase Class Reference

`#include <pubkey.h>`

Inheritance diagram for TF_DecryptorBase:

List of all members.

## Detailed Description

_

Definition at line 166 of file pubkey.h.

## Public Member Functions
DecodingResult | Decrypt (RandomNumberGenerator &rng, const byte *ciphertext, unsigned int ciphertextLength, byte *plaintext, const NameValuePairs &parameters=g_nullNameValuePairs) const
| decrypt a byte string, and return the length of plaintext
bool | ParameterSupported (const char *name) const
| this object supports the use of the parameter with the given name
unsigned int | FixedMaxPlaintextLength () const
| return maximum plaintext length given the fixed ciphertext length, if one exists, otherwise return 0
unsigned int | FixedCiphertextLength () const
| return fixed ciphertext length, if one exists, otherwise return 0
unsigned int | MaxPlaintextLength (unsigned int ciphertextLength) const
| maximum length of plaintext for a given ciphertext length
unsigned int | CiphertextLength (unsigned int plaintextLength) const
| calculate length of ciphertext given length of plaintext
virtual BufferedTransformation * | CreateDecryptionFilter (RandomNumberGenerator &rng, BufferedTransformation *attachment=NULL, const NameValuePairs &parameters=g_nullNameValuePairs) const
| create a new decryption filter
DecodingResult | FixedLengthDecrypt (RandomNumberGenerator &rng, const byte *ciphertext, byte *plaintext, const NameValuePairs &parameters=g_nullNameValuePairs) const
| decrypt a fixed size ciphertext
CryptoMaterial & | AccessMaterial ()
| returns a reference to the crypto material used by this object
const CryptoMaterial & | GetMaterial () const
| returns a const reference to the crypto material used by this object
virtual PrivateKey & | AccessPrivateKey ()=0
virtual const PrivateKey & | GetPrivateKey () const
void | BERDecode (BufferedTransformation &bt)
| for backwards compatibility, calls AccessMaterial().Load(bt)
void | DEREncode (BufferedTransformation &bt) const
| for backwards compatibility, calls GetMaterial().Save(bt)
virtual std::string | AlgorithmName () const
| returns name of this algorithm, not universally implemented yet
virtual Clonable * | Clone () const
| this is not implemented by most classes yet
## Protected Types
typedef TrapdoorFunctionInverse | TrapdoorFunctionInterface
typedef PK_EncryptionMessageEncodingMethod | MessageEncodingInterface
## Protected Member Functions
unsigned int | PaddedBlockByteLength () const
unsigned int | PaddedBlockBitLength () const
virtual const TrapdoorFunctionBounds & | GetTrapdoorFunctionBounds () const=0
virtual const TrapdoorFunctionInterface & | GetTrapdoorFunctionInterface () const=0
virtual const MessageEncodingInterface & | GetMessageEncodingInterface () const=0

## Member Function Documentation

DecodingResult TF_DecryptorBase::Decrypt | ( | RandomNumberGenerator & | rng,
|  | const byte * | ciphertext,
|  | unsigned int | ciphertextLength,
|  | byte * | plaintext,
|  | const NameValuePairs & | parameters = `g_nullNameValuePairs`
| ) | const`[virtual]`

| decrypt a byte string, and return the length of plaintext Precondition: size of plaintext == MaxPlaintextLength(ciphertextLength) bytes. Returns: the actual length of the plaintext, indication that decryption failed. Implements PK_Decryptor. Definition at line 106 of file pubkey.cpp. References PK_CryptoSystem::FixedCiphertextLength(), SecBlock< T, A >::size(), and Integer::Zero().

bool TF_CryptoSystemBase< PK_Decryptor , TF_Base< TrapdoorFunctionInverse, PK_EncryptionMessageEncodingMethod > >::ParameterSupported | ( | const char * | name | ) | const`[inline, virtual, inherited]`

| Implements PK_CryptoSystem. Definition at line 156 of file pubkey.h.

unsigned int TF_CryptoSystemBase< PK_Decryptor , TF_Base< TrapdoorFunctionInverse, PK_EncryptionMessageEncodingMethod > >::FixedCiphertextLength | ( |  | ) | const`[inline, virtual, inherited]`

| Implements PK_FixedLengthCryptoSystemImpl< PK_Decryptor >. Definition at line 158 of file pubkey.h.

unsigned int PK_FixedLengthCryptoSystemImpl< PK_Decryptor >::MaxPlaintextLength | ( | unsigned int | ciphertextLength | ) | const`[inline, virtual, inherited]`

| Implements PK_CryptoSystem. Definition at line 142 of file pubkey.h.

unsigned int PK_FixedLengthCryptoSystemImpl< PK_Decryptor >::CiphertextLength | ( | unsigned int | plaintextLength | ) | const`[inline, virtual, inherited]`

| Implements PK_CryptoSystem. Definition at line 144 of file pubkey.h.

BufferedTransformation * PK_Decryptor::CreateDecryptionFilter | ( | RandomNumberGenerator & | rng,
|  | BufferedTransformation * | attachment = `NULL`,
|  | const NameValuePairs & | parameters = `g_nullNameValuePairs`
| ) | const`[virtual, inherited]`

| create a new decryption filter Note: caller is responsible for deleting the returned pointer Definition at line 610 of file cryptlib.cpp.

The documentation for this class was generated from the following files:

- pubkey.h
- pubkey.cpp